use std::fmt::Display;

pub enum ErrorKind {
    NoSources,
    FormatError,
}

pub struct Error {
    pub kind: ErrorKind,
    pub message: String,
}

impl Display for Error {
    fn fmt(&self, f: &mut std::fmt::Formatter<'_>) -> std::fmt::Result {
        write!(f, "content generation error: {}", self.message)
    }
}

pub type Result<T> = std::result::Result<T, Error>;
