use crate::deser::*;

#[derive(Debug, Clone)]
pub struct Config<'a> {
    pub build_dir: &'a str,
    pub compile_commands: bool,
    pub compile_commands_target: &'a str,
}

impl<'a> From<&'a DeserConfig> for Config<'a> {
    fn from(value: &'a DeserConfig) -> Self {
        let mut ret = Self::get_default();

        if let Some(v) = &value.build_dir {
            ret.build_dir = v;
        }

        if let Some(v) = &value.compile_commands {
            ret.compile_commands = *v;
        }

        if let Some(v) = &value.compile_commands_target {
            ret.compile_commands_target = v;
        }

        ret
    }
}

impl<'a> Config<'a> {
    pub fn get_default() -> Self {
        Self {
            build_dir: "build",
            compile_commands: false,
            compile_commands_target: "main",
        }
    }
}
