use super::*;
use crate::deser::*;
use std::collections::HashMap;

#[derive(Debug, Clone)]
pub struct TargetOptionList<'a>(pub HashMap<&'a str, TargetOptions<'a>>);

impl<'a> From<&'a DeserTargetList> for TargetOptionList<'a> {
    fn from(value: &'a DeserTargetList) -> Self {
        let mut ret: Self = TargetOptionList(HashMap::new());

        for (name, target) in value {
            if let Some(v) = &target.opts {
                ret.0.insert(name, TargetOptions::from(v));
            } else {
                ret.0.insert(name, TargetOptions::get_default());
            }
        }

        ret
    }
}
